/**************************************************/
/*		Barrett Technology Inc.                   */
/*      Timer.c		v2.25                         */
/* 		Created:	JR	1995		              */
/*		Edited:		YM	11/6/95	Copied from JR	  */
/*					YM  12/5/95 Created Delay	  */
/*					YM	12/7/95 Cleaned up 		  */
/**************************************************/

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <io.h>

typedef   unsigned int  UINT;
typedef   unsigned long ULONG; 
#define   NOT  !
#define TICKS_DAY 1573040L                  // number of ticks per day


int     time_out(long *n)                   /* check for a time out event.  */
{
	 // BIOS timer tick counter down in low memory
        static unsigned long far *timer=(unsigned long far *) MK_FP(0x40, 0x6c);
        static unsigned last;               // last accessed time
        static unsigned  work;              // work variable

        work = *timer;                // get current time

        if (*n > 0) {                 // q. first time call?
                *n = -*n;             // a. yes .. change sign
                last = work;          // ..and initialize counters
        }

        if (work != last)  {          // q. time pass?
                                      // a. yes .. see how much
        	if (work <= last)        // q. clock go past midnite?
                (*n)++;               // yes .. count as 1 tick
            else                     // else .. count everything
                *n += (UINT)(work - last);  

             last = work;             // start again w/curr time
        }

        return(*n >= 0L);            // return TRUE at timeout time
}

int delay(long *n)
{
static unsigned long
	far *timer=(unsigned long far *) MK_FP(0x40, 0x6c);
static unsigned currenttime;
static unsigned donetime;  
	donetime = *n + *timer;
	
	while(1) {               
	currenttime = *timer;
	if(currenttime < donetime);
	else break;
	}
	return 1;
}
		               
        
        
        
        
        
        
