/***********************************************************************/
/*             Barrett Technology Inc.                  			   */
/*             Serial.h		v 2.2                      			       */
/*             Created:	JR	1990						  			   */
/*			   Edited:	YM	11/6/95	copied from JR.		               */
/*                      YM  11/6/95 added serial info from softlib.c   */
/***********************************************************************/

#ifndef serial_h
#define serial_h
#include <stdio.h>

extern int Port;

#define   readSerial()           CommPort(Port,2)
#define   flushSerial()          CommPort(Port,5)
#define   checkSerial()          CommPort(Port,1) 

void init_serial(int port);
int CommPort(int, char);                
void myoutp(char b);
void to68_char(char cc);
void to68_uchar(unsigned char cc);
void to68_int(int val);
void to68_long(long val);
void to68_string( char *ss, int n);
int fr68_char(char *cc);
int fr68_uchar(unsigned char *cc);
int fr68_int(int *val);
int fr68_uint(unsigned int *val);
int fr68_long(long *val);
int fr68_string( char *ss, int n);

void asiputc(int port, int c);
void asiString(char *s);
int waitforPrompt();
int waitforAline(char *buffer); 
int err_prompt_detection();


#endif /* serial_h */
