/*====================================================================*
 * TRDAQ.H                                                           *
 * Header file for use with torque ripple data gathering application. *
 *                                                                    * 
 *               1992, 1997 Barrett Technology, Inc.                  *
 *                          Karl Leeser                               *
 *====================================================================*/

/* define color constansts */
#define Black          0
#define Blue           1
#define Green          2
#define Cyan           3
#define Red            4
#define Magenta        5
#define Brown          6
#define White          7
#define Dark_grey      8
#define Light_blue     9
#define Light_green   10
#define Light_cyan    11
#define Light_red     12
#define Light_magenta 13
#define Yellow        14
#define Bright_white  15

/* defines start and end of taking torque data*/
/* an array must exist that can take these as subscripts */
#define END     4096
#define START 0
#define PI   3.1415292654 
#define CONVERT ((END - START) / (PI * 2))

/* number of torque samples to take */
#define SAMPLES 10
#define SCALE 700

/* acceleration and velocity for move command*/
#define VEL 10000
#define ACCEL 100000   




                              
                              